import Vue from 'vue';
import VueRouter from 'vue-router';

import Layout from '@/layouts';
import Login from '@/views/login';

Vue.use(VueRouter);

const routes = [
  {
    path: '/login',
    component: Login
  },
  {
    path: '/404',
    component: () => import('@/views/404')
  },
  {
    path: '/',
    component: Layout,
    redirect: '/main',
    children: [
      {
        path: '/main',
        name: 'Main',
        component: () => import('@/views/teacher/main')
      }
    ]
  },
  {
    path: '/cs_item_detail',
    component: Layout,
    redirect: '/cs_item_detail/index/:id',
    children: [
      {
        path: '/cs_item_detail/index/:id',
        name: 'CSItemDetail',
        component: () => import('@/views/teacher/cs_item_detail')
      }
    ]
  },
  {
    path: '*',
    redirect: '/404'
  }
];

const createRouter = () =>
  new VueRouter({
    mode: 'history',
    scrollBehavior: () => ({ y: 0 }),
    routes
  });

const router = createRouter();

// 重置路由
export function resetRouter() {
  const newRouter = createRouter();
  router.matcher = newRouter.matcher;
}

export default router;
